//! The Weierstrass function. s is the fractal dimension, lamda must be greather than one.
function Weierstrass ( float lamda , float s , void|int iterations )
{
 
  function f = lambda ( float t )
	       {
		 int iter ;
		 float suma = 0.0 ;
		 if(iterations )
		   {
		     iter = iterations ;
		   }
		 else 
		   {
		     iter = 20 ;
		   }
		 for(int k = 0 ; k < iter ; ++k )
		   {
		     
		     suma += pow( lamda , (s - 2) * k ) * sin( pow( lamda , k ) * t ) ;
		   }
		 return suma ;
	       } ;
    return f ;
}


int main ()
{
  int itermax = 150 ;
  function f = Weierstrass( 1.5 , 1.3 , itermax ) ;
  write( f(2.5 ) + "  ,  "  + f(3.75) + " with " + itermax + " iterations \n");
  return 0 ;
}
      