import .Random ;

//! @decl array SimpleMontecarlo( function f , array interval , int points)
//! Uses a simple Montecarlo  algorithm to integrate f in the interval .
//! @param f 
//! The function to integrate
//! @param interval
//! The interval ({ a, b }) where we wish to do the integral.
//! @param points
//! The number of points that the montecarlo algorithm has to use.
array SimpleMontecarlo( function f , array interval , int points)
{
  float mitja = 0 , desviacio = 0 ;
  float sf = 0 , sf2 = 0 ;
  float punt = 0 ;
  float valor = 0;
  float a = interval[0] , b = interval[1];
  float wide = (b - a);
  float aux ;
  //Inicialitze el generador de nombres aleatoris:
  RandomSelfInit();
  for ( int i = 0 ; i < points ; ++i )
    {
      punt = UniformDeviation( a , b ) ;
      aux = f(punt);
      sf += aux ;
      sf2 += pow( aux ,  2 );
    }
  mitja = wide * sf / points ;
  sf2 = wide * sf2 / points ;
  desviacio = wide * abs( (sf2 - mitja) / sqrt(points)) ;
  return ({ mitja, desviacio }) ;
}


int main ()
{
  function f = lambda ( float x ) { return x ; } ;
  array resultat = SimpleMontecarlo( f, ({ 0.0 , 1.0 }) , 10000 ) ;
  write("The integration of f(x)= x between 0 and 1 gives " + resultat[0] + " +- " + resultat[1] + "\n");
  return 0 ;
}
